######################
# ONI TEAM ARENA 1.1 #
######################
# arena_rand.bsl for Rooftops
###############################

################ RANDOM VARIABLES (CORE)
var int rand_cell= 0; var int rand_ammo= 0;
var int rand_invis= 0; var int rand_shield= 0;
var int rand_dead= 0; var int rand_weapon= 0;
var int rand_flag= 0; var int rand_music= 0;
################ THEIR MAX VALUES (CUSTOM)
######## POWERUPS, WEAPONS AND DEATH MESSAGES (LEVEL-INDEPENDENT)
var int rand_cell_max= 6; var int rand_ammo_max= 7;
var int rand_invis_max= 98; var int rand_shield_max= 99;
var int rand_dead_max= 22; var int rand_weapon_max= 14;
######## TELEPORT FLAG (LEVEL- AND AREA-DEPENDENT)
var int rand_flag_max= 22;
######## MUSIC (LEVEL-DEPENDENT)
var int rand_music_max= 3;
################ AUXILIARY VARIABLES (CORE)
var string now_playing; var string next_tune;
var string rand_weapon_name;
###################################################################
################ JUKEBOX (CORE)
func void ArenaMusic(void) {
	sleep 400; now_playing= next_tune; sound_music_start(now_playing);
	sleep 6000; sound_music_stop(now_playing); fork ArenaMusic();
}
################ RANDOMIZER INITIALIZATION (CUSTOM, AREA-SPECIFIC)
func void RandInit(void) {
	rand_cell_max= 6; rand_shield_max= 99;
	rand_ammo_max= 7; rand_invis_max= 98;
	rand_dead_max= 22; rand_weapon_max= 14;
	rand_music_max= 3; ArenaResetFlags();

	now_playing= mus_fitec; next_tune= mus_fitec;
	rand_weapon_name= w6_vdg;
	fork RandGen();
}
func ArenaResetFlags {
	if(arena_area eq 0) rand_flag_max= 22;
	if(arena_area eq 1) rand_flag_max= 22;
	if(arena_area eq 2) rand_flag_max= 22;
	if(arena_area eq 3) rand_flag_max= 9;
}
################ RANDOM NUMBER GENERATOR (CORE)
func void RandGen(void) {
	rand_cell= rand_cell + 1; if(rand_cell > rand_cell_max) rand_cell= 0;
	rand_ammo= rand_ammo + 1; if(rand_ammo > rand_ammo_max) rand_ammo= 0;
	rand_invis= rand_invis + 1; if(rand_invis > rand_invis_max) rand_invis= 0;
	rand_shield= rand_shield + 1; if(rand_shield > rand_shield_max) rand_shield= 0;
	rand_dead= rand_dead + 1; if(rand_dead > rand_dead_max) rand_dead= 0;
	rand_weapon= rand_weapon + 1; if(rand_weapon > rand_weapon_max) rand_weapon= 0
	rand_flag= rand_flag + 1; if(rand_flag > rand_flag_max) rand_flag= 0;
	rand_music= rand_music + 1; if(rand_music > rand_music_max) rand_music= 0;
	sleep 1; fork RandGen();
}
################ CLIENT FUNCTIONS (CUSTOM)
######## POWERUPS (LEVEL-INDEPENDENT)
func void GiveRandPowerups(string ai_name) {
	if(rand_shield > 95) chr_givepowerup(ai_name, shield);
	if(rand_invis  > 95) chr_givepowerup(ai_name, invis);
	chr_givepowerup(ai_name, cell, rand_cell);
	chr_givepowerup(ai_name, ammo, rand_ammo);
}
######## MUSIC FILES (LEVEL-DEPENDENT)
func void RandMusic(void) {
	if(rand_music eq 0) next_tune= mus_cool19;
	if(rand_music eq 1) next_tune= mus_low1;
	if(rand_music eq 2) next_tune= mus_fitec;
	if(rand_music eq 3) next_tune= atm_cl12;
	if(next_tune eq now_playing and now_playing ne mus_fitec) next_tune= mus_fitec;
}
######## WEAPONS (LEVEL-INDEPENDENT)
func void RandWeapon(void) {
	if(rand_weapon eq  0) rand_weapon_name=  w6_vdg;
	if(rand_weapon eq  1) rand_weapon_name=  w3_phr;
	if(rand_weapon eq  2) rand_weapon_name=  w7_scc;
	if(rand_weapon eq  3) rand_weapon_name=  w1_tap;
	if(rand_weapon eq  4) rand_weapon_name=  w2_sap;
	if(rand_weapon eq  5) rand_weapon_name=  w3_phr;
	if(rand_weapon eq  6) rand_weapon_name=  w4_psm;
	if(rand_weapon eq  7) rand_weapon_name=  w5_sbg;
	if(rand_weapon eq  8) rand_weapon_name=  w6_vdg;
	if(rand_weapon eq  9) rand_weapon_name=  w7_scc;
	if(rand_weapon eq 10) rand_weapon_name=  w8_mbo;
	if(rand_weapon eq 11) rand_weapon_name=  w9_scr;
	if(rand_weapon eq 12) rand_weapon_name=  w8_mbo;
	if(rand_weapon eq 13) rand_weapon_name= w11_ba1;
	if(rand_weapon eq 14) rand_weapon_name=  w4_psm;
}
######## TELEPORT FLAGS (LEVEL- AND AREA-DEPENDENT)
func void SendToRandFlag(string ai_name, string ai_team) {
	if(arena_area eq 0) {
################ ROOFTOPS : BIG BROTHERS
		if(rand_flag eq  0)
			{chr_teleport(ai_name,   66); chr_facetoflag(ai_name,   66);}
		if(rand_flag eq  1)
			{chr_teleport(ai_name,   67); chr_facetoflag(ai_name,   67);}
		if(rand_flag eq  2)
			{chr_teleport(ai_name,   68); chr_facetoflag(ai_name,   68);}
		if(rand_flag eq  3)
			{chr_teleport(ai_name,   69); chr_facetoflag(ai_name,   69);}
		if(rand_flag eq  4)
			{chr_teleport(ai_name,   70); chr_facetoflag(ai_name,   70);}
		if(rand_flag eq  5)
			{chr_teleport(ai_name,   71); chr_facetoflag(ai_name,   71);}
		if(rand_flag eq  6)
			{chr_teleport(ai_name,   72); chr_facetoflag(ai_name,   72);}
		if(rand_flag eq  7)
			{chr_teleport(ai_name,   73); chr_facetoflag(ai_name,   73);}
		if(rand_flag eq  8)
			{chr_teleport(ai_name,   74); chr_facetoflag(ai_name,   74);}
		if(rand_flag eq  9)
			{chr_teleport(ai_name,   75); chr_facetoflag(ai_name,   75);}
		if(rand_flag eq 10)
			{chr_teleport(ai_name,   76); chr_facetoflag(ai_name,   76);}
		if(rand_flag eq 11)
			{chr_teleport(ai_name,   77); chr_facetoflag(ai_name,   77);}
		if(rand_flag eq 12)
			{chr_teleport(ai_name,   78); chr_facetoflag(ai_name,   78);}
		if(rand_flag eq 13)
			{chr_teleport(ai_name,   79); chr_facetoflag(ai_name,   79);}
		if(rand_flag eq 14)
			{chr_teleport(ai_name,   80); chr_facetoflag(ai_name,   80);}
		if(rand_flag eq 15)
			{chr_teleport(ai_name,   81); chr_facetoflag(ai_name,   81);}
		if(rand_flag eq 16)
			{chr_teleport(ai_name,   86); chr_facetoflag(ai_name,   86);}
		if(rand_flag eq 17)
			{chr_teleport(ai_name,  105); chr_facetoflag(ai_name,  105);}
		if(rand_flag eq 18)
			{chr_teleport(ai_name,  106); chr_facetoflag(ai_name,  106);}
		if(rand_flag eq 19)
			{chr_teleport(ai_name,  107); chr_facetoflag(ai_name,  107);}
		if(rand_flag eq 20)
			{chr_teleport(ai_name,  108); chr_facetoflag(ai_name,  108);}
		if(rand_flag eq 21)
			{chr_teleport(ai_name, 7018); chr_facetoflag(ai_name, 7018);}
		if(rand_flag >  21)
			{chr_teleport(ai_name, 7025); chr_facetoflag(ai_name, 7025);}
	}
	if(arena_area eq 1) {
################ MUKADE'S FATE
		if(rand_flag eq  0)
			{chr_teleport(ai_name, 9516); chr_facetoflag(ai_name, 9516);}
		if(rand_flag eq  1)
			{chr_teleport(ai_name, 9517); chr_facetoflag(ai_name, 9517);}
		if(rand_flag eq  2)
			{chr_teleport(ai_name, 9518); chr_facetoflag(ai_name, 9518);}
		if(rand_flag eq  3)
			{chr_teleport(ai_name, 9519); chr_facetoflag(ai_name, 9519);}
		if(rand_flag eq  4)
			{chr_teleport(ai_name, 9520); chr_facetoflag(ai_name, 9520);}
		if(rand_flag eq  5)
			{chr_teleport(ai_name, 9521); chr_facetoflag(ai_name, 9521);}
		if(rand_flag eq  6)
			{chr_teleport(ai_name, 9522); chr_facetoflag(ai_name, 9522);}
		if(rand_flag eq  7)
			{chr_teleport(ai_name, 9523); chr_facetoflag(ai_name, 9523);}
		if(rand_flag eq  8)
			{chr_teleport(ai_name, 9524); chr_facetoflag(ai_name, 9524);}
		if(rand_flag eq  9)
			{chr_teleport(ai_name, 9525); chr_facetoflag(ai_name, 9525);}
		if(rand_flag eq 10)
			{chr_teleport(ai_name, 9526); chr_facetoflag(ai_name, 9526);}
		if(rand_flag eq 11)
			{chr_teleport(ai_name, 9527); chr_facetoflag(ai_name, 9527);}
		if(rand_flag eq 12)
			{chr_teleport(ai_name, 9528); chr_facetoflag(ai_name, 9528);}
		if(rand_flag eq 13)
			{chr_teleport(ai_name, 9529); chr_facetoflag(ai_name, 9529);}
		if(rand_flag eq 14)
			{chr_teleport(ai_name, 9530); chr_facetoflag(ai_name, 9530);}
		if(rand_flag eq 15)
			{chr_teleport(ai_name, 9531); chr_facetoflag(ai_name, 9531);}
		if(rand_flag eq 16)
			{chr_teleport(ai_name, 9532); chr_facetoflag(ai_name, 9532);}
		if(rand_flag eq 17)
			{chr_teleport(ai_name, 9533); chr_facetoflag(ai_name, 9533);}
		if(rand_flag eq 18)
			{chr_teleport(ai_name, 9534); chr_facetoflag(ai_name, 9534);}
		if(rand_flag eq 19)
			{chr_teleport(ai_name, 9535); chr_facetoflag(ai_name, 9535);}
		if(rand_flag eq 20)
			{chr_teleport(ai_name, 9536); chr_facetoflag(ai_name, 9536);}
		if(rand_flag eq 21)
			{chr_teleport(ai_name, 9537); chr_facetoflag(ai_name, 9537);}
		if(rand_flag >  21)
			{chr_teleport(ai_name, 9538); chr_facetoflag(ai_name, 9538);}
	}
	if(arena_area eq 2) {
################ SIAMESE TWINS
		if(rand_flag eq  0)
			{chr_teleport(ai_name,    9); chr_facetoflag(ai_name,    9);}
		if(rand_flag eq  1)
			{chr_teleport(ai_name,   10); chr_facetoflag(ai_name,   10);}
		if(rand_flag eq  2)
			{chr_teleport(ai_name,   11); chr_facetoflag(ai_name,   11);}
		if(rand_flag eq  3)
			{chr_teleport(ai_name,   15); chr_facetoflag(ai_name,   15);}
		if(rand_flag eq  4)
			{chr_teleport(ai_name,   16); chr_facetoflag(ai_name,   16);}
		if(rand_flag eq  5)
			{chr_teleport(ai_name,   17); chr_facetoflag(ai_name,   17);}
		if(rand_flag eq  6)
			{chr_teleport(ai_name,   18); chr_facetoflag(ai_name,   18);}
		if(rand_flag eq  7)
			{chr_teleport(ai_name,   19); chr_facetoflag(ai_name,   19);}
		if(rand_flag eq  8)
			{chr_teleport(ai_name,   22); chr_facetoflag(ai_name,   22);}
		if(rand_flag eq  9)
			{chr_teleport(ai_name,   24); chr_facetoflag(ai_name,   24);}
		if(rand_flag eq 10)
			{chr_teleport(ai_name,   26); chr_facetoflag(ai_name,   26);}
		if(rand_flag eq 11)
			{chr_teleport(ai_name,   27); chr_facetoflag(ai_name,   27);}
		if(rand_flag eq 12)
			{chr_teleport(ai_name,   28); chr_facetoflag(ai_name,   28);}
		if(rand_flag eq 13)
			{chr_teleport(ai_name,  100); chr_facetoflag(ai_name,  100);}
		if(rand_flag eq 14)
			{chr_teleport(ai_name,  123); chr_facetoflag(ai_name,  123);}
		if(rand_flag eq 15)
			{chr_teleport(ai_name,  124); chr_facetoflag(ai_name,  124);}
		if(rand_flag eq 16)
			{chr_teleport(ai_name,  127); chr_facetoflag(ai_name,  127);}
		if(rand_flag eq 17)
			{chr_teleport(ai_name,  128); chr_facetoflag(ai_name,  128);}
		if(rand_flag eq 18)
			{chr_teleport(ai_name,  129); chr_facetoflag(ai_name,  129);}
		if(rand_flag eq 19)
			{chr_teleport(ai_name,  131); chr_facetoflag(ai_name,  131);}
		if(rand_flag eq 20)
			{chr_teleport(ai_name, 7021); chr_facetoflag(ai_name, 7021);}
		if(rand_flag eq 21)
			{chr_teleport(ai_name, 7024); chr_facetoflag(ai_name, 7024);}
		if(rand_flag >  21)
			{chr_teleport(ai_name, 7026); chr_facetoflag(ai_name, 7026);}
	}
	if(arena_area eq 3) {
################ SKIRMISH INC.
		if(rand_flag eq 0)
			{chr_teleport(ai_name,   88); chr_facetoflag(ai_name,   88);}
		if(rand_flag eq 1)
			{chr_teleport(ai_name,   89); chr_facetoflag(ai_name,   89);}
		if(rand_flag eq 2)
			{chr_teleport(ai_name,   90); chr_facetoflag(ai_name,   90);}
		if(rand_flag eq 3)
			{chr_teleport(ai_name,   91); chr_facetoflag(ai_name,   88);}
		if(rand_flag eq 4)
			{chr_teleport(ai_name,   94); chr_facetoflag(ai_name,   94);}
		if(rand_flag eq 5)
			{chr_teleport(ai_name,   95); chr_facetoflag(ai_name,   95);}
		if(rand_flag eq 6)
			{chr_teleport(ai_name,   97); chr_facetoflag(ai_name,   97);}
		if(rand_flag eq 7)
			{chr_teleport(ai_name,   98); chr_facetoflag(ai_name,   98);}
		if(rand_flag eq 8)
			{chr_teleport(ai_name,   99); chr_facetoflag(ai_name,   99);}
		if(rand_flag >  8)
			{chr_teleport(ai_name,  101); chr_facetoflag(ai_name,  101);}
	}
	chr_animate(ai_name, NINCOMteleport_out);
}
######## DEATH MESSAGES (LEVEL-INDEPENDENT)
func RandDead {
	if(rand_dead eq  0) dmsg "is dead"
	if(rand_dead eq  1) dmsg "is no more"
	if(rand_dead eq  2) dmsg "has ceased to be"
	if(rand_dead eq  3) dmsg "has expired"
	if(rand_dead eq  4) dmsg "is history"
	if(rand_dead eq  5) dmsg "has been neutralized"
	if(rand_dead eq  6) dmsg "has been annihilated"
	if(rand_dead eq  7) dmsg "has died"
	if(rand_dead eq  8) dmsg "has turned to dust"
	if(rand_dead eq  9) dmsg "has bitten the dust"
	if(rand_dead eq 10) dmsg "has gone"
	if(rand_dead eq 11) dmsg "will come back"
	if(rand_dead eq 12) dmsg "has been obliterated"
	if(rand_dead eq 13) dmsg "has been destroyed"
	if(rand_dead eq 14) dmsg "has been wiped out"
	if(rand_dead eq 15) dmsg "is a stiff"
	if(rand_dead eq 16) dmsg "has passed on"
	if(rand_dead eq 17) dmsg "has been destroyed"
	if(rand_dead eq 18) dmsg "is late"
	if(rand_dead eq 19) dmsg "rests in peace"
	if(rand_dead eq 20) dmsg "is bereft of life"
	if(rand_dead eq 21) dmsg "is deceased"
	if(rand_dead eq 22) dmsg "is demised"
	if(rand_dead >  22) dmsg "is dead"
}
